## soapdenovo 1.05

=== Makefile ===
.NOTPARALLEL:
.PHONY: all compile mer31 mer63 mer127 install clean

all:		compile install
	
compile:	mer31 mer63 mer127

mer31:
		@cd ./src/31mer; make
mer63:
		@cd ./src/63mer; make
mer127:
		@cd ./src/127mer; make
install:
		@cp ./src/*/SOAPdenovo* ./bin/
		@printf "Installation done.\n"
clean:
		@cd ./src/31mer; make clean
		@cd ./src/63mer; make clean
		@cd ./src/127mer; make clean
		@cd ./bin; rm -f SOAPdenovo*

=== src/127mer/Makefile ===
CC=             gcc
CFLAGS=         -O3 -fomit-frame-pointer 
DFLAGS= 
OBJS=		arc.o attachPEinfo.o bubble.o check.o compactEdge.o \
		concatenateEdge.o connect.o contig.o cutTipPreGraph.o cutTip_graph.o \
		darray.o dfib.o dfibHeap.o fib.o fibHeap.o \
		hashFunction.o kmer.o lib.o loadGraph.o loadPath.o \
		loadPreGraph.o localAsm.o main.o map.o mem_manager.o \
		newhash.o node2edge.o orderContig.o output_contig.o output_pregraph.o \
		output_scaffold.o pregraph.o prlHashCtg.o prlHashReads.o prlRead2Ctg.o \
		prlRead2path.o prlReadFillGap.o read2scaf.o readInterval.o stack.o\
		readseq1by1.o scaffold.o searchPath.o seq.o splitReps.o
PROG=           SOAPdenovo-127mer
INCLUDES=	-Iinc
SUBDIRS=        . 
LIBPATH=	
LIBS=      	-pthread -lm
EXTRA_FLAGS=

BIT_ERR = 0
ifeq (,$(findstring $(shell uname -m), x86_64 ppc64 ia64))
BIT_ERR = 1
endif


LINUX = 0
ifneq (,$(findstring Linux,$(shell uname)))
LINUX = 1
EXTRA_FLAGS += -Wl,--hash-style=both
endif

ifneq (,$(findstring $(shell uname -m), x86_64))
CFLAGS += -m64
endif

ifneq (,$(findstring $(shell uname -m), ia64))
CFLAGS += 
endif

ifneq (,$(findstring $(shell uname -m), ppc64))
CFLAGS += -m64 -mpowerpc64
endif

.SUFFIXES:.c .o

.c.o:
		@printf "Compiling $<...                             \r"; \
		$(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $< || echo "Error in command: $(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $<"

all:		SOAPdenovo

.PHONY:all clean install

envTest:
		@test $(BIT_ERR) != 1 || sh -c 'echo "Fatal: 64bit CPU and Operating System required!";false;'

SOAPdenovo:	envTest $(OBJS)
		@$(CC) $(CFLAGS) -o $(PROG) $(OBJS) $(LIBPATH) $(LIBS) $(ENTRAFLAGS)
		@printf "Linking...\r"
		@printf "$(PROG) compilation done.\n";

clean:
		@rm -fr gmon.out *.o a.out *.exe *.dSYM $(PROG) *~ *.a *.so.* *.so *.dylib
		@printf "$(PROG) cleaning done.\n";

install:
		@cp $(PROG) ../../bin/
		@printf "$(PROG) installed at ../../bin/$(PROG)\n"

=== src/31mer/Makefile ===
CC=             gcc
CFLAGS=         -O3 -fomit-frame-pointer
DFLAGS= 
OBJS=		arc.o attachPEinfo.o bubble.o check.o compactEdge.o \
		concatenateEdge.o connect.o contig.o cutTipPreGraph.o cutTip_graph.o \
		darray.o dfib.o dfibHeap.o fib.o fibHeap.o \
		hashFunction.o kmer.o lib.o loadGraph.o loadPath.o \
		loadPreGraph.o localAsm.o main.o map.o mem_manager.o \
		newhash.o node2edge.o orderContig.o output_contig.o output_pregraph.o \
		output_scaffold.o pregraph.o prlHashCtg.o prlHashReads.o prlRead2Ctg.o \
		prlRead2path.o prlReadFillGap.o read2scaf.o readInterval.o stack.o\
		readseq1by1.o scaffold.o searchPath.o seq.o splitReps.o
PROG=           SOAPdenovo-31mer
INCLUDES=	-Iinc
SUBDIRS=        . 
LIBPATH=	
LIBS=      	-pthread -lm
EXTRA_FLAGS=

BIT_ERR = 0
ifeq (,$(findstring $(shell uname -m), x86_64 ppc64 ia64))
BIT_ERR = 1
endif


LINUX = 0
ifneq (,$(findstring Linux,$(shell uname)))
LINUX = 1
EXTRA_FLAGS += -Wl,--hash-style=both
endif

ifneq (,$(findstring $(shell uname -m), x86_64))
CFLAGS += -m64
endif

ifneq (,$(findstring $(shell uname -m), ia64))
CFLAGS += 
endif

ifneq (,$(findstring $(shell uname -m), ppc64))
CFLAGS += -m64 -mpowerpc64
endif

.SUFFIXES:.c .o

.c.o:
		@printf "Compiling $<...                             \r"; \
		$(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $< || echo "Error in command: $(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $<"

all:		SOAPdenovo

.PHONY:all clean install

envTest:
		@test $(BIT_ERR) != 1 || sh -c 'echo "Fatal: 64bit CPU and Operating System required!";false;'

SOAPdenovo:	envTest $(OBJS)
		@$(CC) $(CFLAGS) -o $(PROG) $(OBJS) $(LIBPATH) $(LIBS) $(ENTRAFLAGS)
		@printf "Linking...\r"
		@printf "$(PROG) compilation done.\n";

clean:
		@rm -fr gmon.out *.o a.out *.exe *.dSYM $(PROG) *~ *.a *.so.* *.so *.dylib
		@printf "$(PROG) cleaning done.\n";

install:
		@cp $(PROG) ../../bin/
		@printf "$(PROG) installed at ../../bin/$(PROG)\n"

=== src/63mer/Makefile ===
CC=             gcc
CFLAGS=         -O3 -fomit-frame-pointer 
DFLAGS= 
OBJS=		arc.o attachPEinfo.o bubble.o check.o compactEdge.o \
		concatenateEdge.o connect.o contig.o cutTipPreGraph.o cutTip_graph.o \
		darray.o dfib.o dfibHeap.o fib.o fibHeap.o \
		hashFunction.o kmer.o lib.o loadGraph.o loadPath.o \
		loadPreGraph.o localAsm.o main.o map.o mem_manager.o \
		newhash.o node2edge.o orderContig.o output_contig.o output_pregraph.o \
		output_scaffold.o pregraph.o prlHashCtg.o prlHashReads.o prlRead2Ctg.o \
		prlRead2path.o prlReadFillGap.o read2scaf.o readInterval.o stack.o\
		readseq1by1.o scaffold.o searchPath.o seq.o splitReps.o
PROG=           SOAPdenovo-63mer
INCLUDES=	-Iinc
SUBDIRS=        . 
LIBPATH=	
LIBS=      	-pthread -lm
EXTRA_FLAGS=

BIT_ERR = 0
ifeq (,$(findstring $(shell uname -m), x86_64 ppc64 ia64))
BIT_ERR = 1
endif


LINUX = 0
ifneq (,$(findstring Linux,$(shell uname)))
LINUX = 1
EXTRA_FLAGS += -Wl,--hash-style=both
endif

ifneq (,$(findstring $(shell uname -m), x86_64))
CFLAGS += -m64
endif

ifneq (,$(findstring $(shell uname -m), ia64))
CFLAGS += 
endif

ifneq (,$(findstring $(shell uname -m), ppc64))
CFLAGS += -m64 -mpowerpc64
endif

.SUFFIXES:.c .o

.c.o:
		@printf "Compiling $<...                             \r"; \
		$(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $< || echo "Error in command: $(CC) -c $(CFLAGS) $(DFLAGS) $(INCLUDES) $<"

all:		SOAPdenovo

.PHONY:all clean install

envTest:
		@test $(BIT_ERR) != 1 || sh -c 'echo "Fatal: 64bit CPU and Operating System required!";false;'

SOAPdenovo:	envTest $(OBJS)
		@$(CC) $(CFLAGS) -o $(PROG) $(OBJS) $(LIBPATH) $(LIBS) $(ENTRAFLAGS)
		@printf "Linking...\r"
		@printf "$(PROG) compilation done.\n";

clean:
		@rm -fr gmon.out *.o a.out *.exe *.dSYM $(PROG) *~ *.a *.so.* *.so *.dylib
		@printf "$(PROG) cleaning done.\n";

install:
		@cp $(PROG) ../../bin/
		@printf "$(PROG) installed at ../../bin/$(PROG)\n"

=== debian/changelog ===
soapdenovo (1.05-7) unstable; urgency=medium

  * Team upload.
  * gcc-15.patch: new: fix build failure with gcc-15. (Closes: #1097907)
  * d/watch: convert to untrackable watch file v5.
  * build-flags.patch: new: propagate build flags.
    This notably fixes missing binaries hardening.
  * add_debug_symbols.patch: normalize Last-Update timestamp.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/control: declare compliance to standards version 4.7.2.

 -- Étienne Mollier <emollier@debian.org>  Wed, 22 Oct 2025 23:26:00 +0200

soapdenovo (1.05-6) unstable; urgency=medium

  * Team upload.
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Secure URI in copyright format (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Remove trailing whitespace in debian/rules (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).
  * Use -fcommon option to tolerate "multiple definition of"

 -- Andreas Tille <tille@debian.org>  Fri, 30 Oct 2020 22:53:04 +0100

soapdenovo (1.05-5) unstable; urgency=medium

  * Team upload

  [ Steffen Moeller ]
  * debian/upstream/metadata:
    - Added references to registries.
    - yamllint clean

  [ Liubov Chuprikova ]
  * Add autopkgtest
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4
  * debhelper 11
  * fix "spelling-error-in-manpage"
  * Add patch that adds debug symbols

 -- Liubov Chuprikova <chuprikovalv@gmail.com>  Sat, 09 Jun 2018 13:09:35 +0200

soapdenovo (1.05-4) unstable; urgency=medium

  * Team upload
  * Moved packaging to Git
  * Build-Depends: rename
    Closes: #874424
  * Standards-Version: 4.1.0 (no changes needed)

 -- Andreas Tille <tille@debian.org>  Wed, 06 Sep 2017 11:08:47 +0200

soapdenovo (1.05-3) unstable; urgency=medium

  * Team upload
  * debian/upstream moved to debian/upstream/metadata
  * d/watch: Source not available any more at download page
  * cme fix dpkg-control
  * debhelper 10
  * hardening=+all

 -- Andreas Tille <tille@debian.org>  Fri, 02 Dec 2016 09:26:22 +0100

soapdenovo (1.05-2) unstable; urgency=low

  * soapdenovo is not maintained anymore, please use
    soapdenovo2 (Closes: #732281).

 -- Olivier Sallou <osallou@debian.org>  Wed, 18 Dec 2013 12:32:59 +0100

soapdenovo (1.05-1) unstable; urgency=low

  * Initial release (Closes: #683291)

 -- Olivier Sallou <osallou@debian.org>  Mon, 30 Jul 2012 15:47:51 +0200

=== debian/control ===
Source: soapdenovo
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Olivier Sallou <osallou@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               rename
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/med-team/soapdenovo
Vcs-Git: https://salsa.debian.org/med-team/soapdenovo.git
Homepage: http://soap.genomics.org.cn/soapdenovo.html

Package: soapdenovo
Architecture: any-amd64 any-ppc64 any-ia64
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: short-read assembly method to build de novo draft assembly
 SOAPdenovo is a novel short-read assembly method that can build a de novo draft
 assembly for the human-sized genomes. The program is specially designed to
 assemble Illumina GA short reads.
 .
 It creates new opportunities for building reference
 sequences and carrying out accurate analyses of unexplored genomes in a cost
 effective way.
 .
 This version is not maintained anymore, consider using soapdenovo2.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# FIXME: This is discouraged ... but works for the moment to solve bug #957194
#        https://wiki.gentoo.org/wiki/Gcc_10_porting_notes/fno_common#The_-fcommon_workaround_.28discouraged.29
export DEB_CFLAGS_MAINT_APPEND=-fcommon

%:
	dh $@

override_dh_install:
	dh_install
	cd debian/soapdenovo/usr/bin/;rename 's/SOAP/soap/' SOAP*

=== debian/tests/control ===
Tests: run-unit-test
Depends: @

=== debian/watch ===
Version: 5
Untrackable: not available any more.

Source: http://soap.genomics.org.cn/soapdenovo.html#down2
Matching-Pattern: down/SOAPdenovo-V(.*)\.src\.tgz
Filenamemangle: s/down\/SOAPdenovo-V/soapdenovo-/
